diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
index fedbd41da..77a5162ef 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightingCache;
 import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
@@ -12,7 +13,6 @@ import org.joml.primitives.AABBdc;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Side;
@@ -111,11 +111,11 @@ public final class RenderBlocks {
     }
 
     @Deprecated
-    public boolean renderStandardBlock(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, int x, int y, int z) {
+    public boolean renderStandardBlock(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, int x, int y, int z) {
         return renderStandardBlock(tessellator, worldSource, blockModel, bounds, new TilePos(x, y, z));
     }
 
-    public boolean renderStandardBlock(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, @NotNull TilePosc tilePos) {
+    public boolean renderStandardBlock(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, @NotNull TilePosc tilePos) {
         int color = BlockColorDispatcher.getInstance().getDispatch(blockModel.block).getWorldColor(worldSource, tilePos, 0);
         float r = (float) (color >> 16 & 0xff) / 255F;
         float g = (float) (color >> 8 & 0xff) / 255F;
@@ -128,11 +128,11 @@ public final class RenderBlocks {
      * Thanks! :D
      */
     @Deprecated
-    public boolean renderStandardBlock(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, int x, int y, int z, float r, float g, float b) {
+    public boolean renderStandardBlock(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, int x, int y, int z, float r, float g, float b) {
         return renderStandardBlock(tessellator, worldSource, blockModel, bounds, new TilePos(x, y, z), r, g, b);
     }
 
-    public boolean renderStandardBlock(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, float r, float g, float b) {
+    public boolean renderStandardBlock(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, float r, float g, float b) {
         this.enableAO = true;
         int meta = worldSource.getBlockData(tilePos);
         this.cache.setupCache(blockModel.block, worldSource, tilePos);
@@ -145,11 +145,11 @@ public final class RenderBlocks {
     }
 
     @Deprecated
-    public boolean renderSide(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, int x, int y, int z, float r, float g, float b, @NotNull Side side, int meta) {
+    public boolean renderSide(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, int x, int y, int z, float r, float g, float b, @NotNull Side side, int meta) {
         return renderSide(tessellator, worldSource, blockModel, bounds, new TilePos(x, y, z), r, g, b, side, meta);
     }
 
-    public boolean renderSide(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, float r, float g, float b, @NotNull Side side, int meta) {
+    public boolean renderSide(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, float r, float g, float b, @NotNull Side side, int meta) {
         boolean useColor;
         return switch (side) {
             case BOTTOM -> {
@@ -208,7 +208,7 @@ public final class RenderBlocks {
      * @author CyborgCabbage
      * Thanks! :D
      */
-    public boolean renderSide(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds,
+    public boolean renderSide(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds,
                               @NotNull TilePosc tilePos, float r, float g, float b, @NotNull Side side, int meta,
                               int dirX, int dirY, int dirZ, float depth,
                               int topX, int topY, int topZ, float topP, float botP,
@@ -262,8 +262,22 @@ public final class RenderBlocks {
         boolean ao = this.mc.isAmbientOcclusionEnabled() && block.emission == 0;
         boolean isFullCube = depth <= FULL_CUBE_THRESHOLD;
 
-        if (LightmapHelper.isLightmapEnabled()) {
-            if (this.overbright) {
+        if (this.overbright) {
+            int dirX2 = dirX;
+            int dirY2 = dirY;
+            int dirZ2 = dirZ;
+
+            if (!isFullCube) {
+                dirX2 = 0;
+                dirY2 = 0;
+                dirZ2 = 0;
+            }
+
+            int lmc = LightmapHelper.getOverbrightLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, dirX2, dirY2, dirZ2));
+
+            this.lightmapCoordTopLeft = this.lightmapCoordBottomLeft = this.lightmapCoordBottomRight = this.lightmapCoordTopRight = lmc;
+        } else {
+            if (ao) {
                 int dirX2 = dirX;
                 int dirY2 = dirY;
                 int dirZ2 = dirZ;
@@ -274,56 +288,40 @@ public final class RenderBlocks {
                     dirZ2 = 0;
                 }
 
-                int lmc = LightmapHelper.getOverbrightLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, dirX2, dirY2, dirZ2));
+                boolean topT = this.cache.getOpacity(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
+                boolean botT = this.cache.getOpacity(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
+                boolean lefT = this.cache.getOpacity(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
+                boolean rigT = this.cache.getOpacity(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
 
-                this.lightmapCoordTopLeft = this.lightmapCoordBottomLeft = this.lightmapCoordBottomRight = this.lightmapCoordTopRight = lmc;
+                boolean topLefT = this.cache.getOpacity(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ);
+                boolean topRigT = this.cache.getOpacity(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ);
+                boolean botLefT = this.cache.getOpacity(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ);
+                boolean botRigT = this.cache.getOpacity(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ);
+
+                int lmcCen = this.cache.getLightmapCoord(dirX2, dirY2, dirZ2);
+
+                int lmcTop = topT ? lmcCen : this.cache.getLightmapCoord(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
+                int lmcBot = botT ? lmcCen : this.cache.getLightmapCoord(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
+                int lmcLef = lefT ? lmcCen : this.cache.getLightmapCoord(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
+                int lmcRig = rigT ? lmcCen : this.cache.getLightmapCoord(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
+
+                int lmcTopLef = topT && lefT ? lmcLef : (topLefT ? lmcCen : this.cache.getLightmapCoord(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ));
+                int lmcBotLef = botT && lefT ? lmcLef : (botLefT ? lmcCen : this.cache.getLightmapCoord(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ));
+                int lmcTopRig = topT && rigT ? lmcRig : (topRigT ? lmcCen : this.cache.getLightmapCoord(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ));
+                int lmcBotRig = botT && rigT ? lmcRig : (botRigT ? lmcCen : this.cache.getLightmapCoord(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ));
+
+                this.lightmapCoordTopLeft = LightmapHelper.avg(lmcCen, lmcLef, lmcTop, lmcTopLef);
+                this.lightmapCoordTopRight = LightmapHelper.avg(lmcCen, lmcRig, lmcTop, lmcTopRig);
+                this.lightmapCoordBottomLeft = LightmapHelper.avg(lmcCen, lmcLef, lmcBot, lmcBotLef);
+                this.lightmapCoordBottomRight = LightmapHelper.avg(lmcCen, lmcRig, lmcBot, lmcBotRig);
             } else {
-                if (ao) {
-                    int dirX2 = dirX;
-                    int dirY2 = dirY;
-                    int dirZ2 = dirZ;
-
-                    if (!isFullCube) {
-                        dirX2 = 0;
-                        dirY2 = 0;
-                        dirZ2 = 0;
-                    }
-
-                    boolean topT = this.cache.getOpacity(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
-                    boolean botT = this.cache.getOpacity(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
-                    boolean lefT = this.cache.getOpacity(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
-                    boolean rigT = this.cache.getOpacity(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
-
-                    boolean topLefT = this.cache.getOpacity(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ);
-                    boolean topRigT = this.cache.getOpacity(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ);
-                    boolean botLefT = this.cache.getOpacity(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ);
-                    boolean botRigT = this.cache.getOpacity(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ);
-
-                    int lmcCen = this.cache.getLightmapCoord(dirX2, dirY2, dirZ2);
-
-                    int lmcTop = topT ? lmcCen : this.cache.getLightmapCoord(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
-                    int lmcBot = botT ? lmcCen : this.cache.getLightmapCoord(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
-                    int lmcLef = lefT ? lmcCen : this.cache.getLightmapCoord(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
-                    int lmcRig = rigT ? lmcCen : this.cache.getLightmapCoord(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
-
-                    int lmcTopLef = topT && lefT ? lmcLef : (topLefT ? lmcCen : this.cache.getLightmapCoord(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ));
-                    int lmcBotLef = botT && lefT ? lmcLef : (botLefT ? lmcCen : this.cache.getLightmapCoord(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ));
-                    int lmcTopRig = topT && rigT ? lmcRig : (topRigT ? lmcCen : this.cache.getLightmapCoord(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ));
-                    int lmcBotRig = botT && rigT ? lmcRig : (botRigT ? lmcCen : this.cache.getLightmapCoord(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ));
-
-                    this.lightmapCoordTopLeft = LightmapHelper.avg(lmcCen, lmcLef, lmcTop, lmcTopLef);
-                    this.lightmapCoordTopRight = LightmapHelper.avg(lmcCen, lmcRig, lmcTop, lmcTopRig);
-                    this.lightmapCoordBottomLeft = LightmapHelper.avg(lmcCen, lmcLef, lmcBot, lmcBotLef);
-                    this.lightmapCoordBottomRight = LightmapHelper.avg(lmcCen, lmcRig, lmcBot, lmcBotRig);
+                int lmc;
+                if (!isFullCube) {
+                    lmc = block.getLightmapCoord(worldSource, tilePos);
                 } else {
-                    int lmc;
-                    if (!isFullCube) {
-                        lmc = block.getLightmapCoord(worldSource, tilePos);
-                    } else {
-                        lmc = block.getLightmapCoord(worldSource, tilePos.add(dirX, dirY, dirZ, new TilePos()));
-                    }
-                    this.lightmapCoordTopLeft = this.lightmapCoordBottomLeft = this.lightmapCoordBottomRight = this.lightmapCoordTopRight = lmc;
+                    lmc = block.getLightmapCoord(worldSource, tilePos.add(dirX, dirY, dirZ, new TilePos()));
                 }
+                this.lightmapCoordTopLeft = this.lightmapCoordBottomLeft = this.lightmapCoordBottomRight = this.lightmapCoordTopRight = lmc;
             }
         }
 
@@ -427,11 +425,11 @@ public final class RenderBlocks {
         this.colorBlueTopRight *= ltr;
     }
 
-    public void renderBottomFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
+    public void renderBottomFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
         renderBottomFace(tessellator, bounds, tilePos.x(), tilePos.y(), tilePos.z(), tex);
     }
 
-    public void renderBottomFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
+    public void renderBottomFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
         if (this.overrideBlockTexture != null) tex = this.overrideBlockTexture;
         if (tex == null) return;
         double d3 = tex.getSubIconU(bounds.minX());
@@ -488,17 +486,17 @@ public final class RenderBlocks {
         double d14 = z + bounds.minZ();
         double d15 = z + bounds.maxZ();
         if (this.enableAO) {
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordTopLeft);
-            tessellator.setColorOpaque_F(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
+            tessellator.setLightmapCoord1i(this.lightmapCoordTopLeft);
+            tessellator.setColorOpaque3f(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
             tessellator.addVertexWithUV(d11, d13, d15, d8, d10);
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordBottomLeft);
-            tessellator.setColorOpaque_F(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
+            tessellator.setLightmapCoord1i(this.lightmapCoordBottomLeft);
+            tessellator.setColorOpaque3f(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
             tessellator.addVertexWithUV(d11, d13, d14, d3, d5);
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordBottomRight);
-            tessellator.setColorOpaque_F(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
+            tessellator.setLightmapCoord1i(this.lightmapCoordBottomRight);
+            tessellator.setColorOpaque3f(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
             tessellator.addVertexWithUV(d12, d13, d14, d7, d9);
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordTopRight);
-            tessellator.setColorOpaque_F(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
+            tessellator.setLightmapCoord1i(this.lightmapCoordTopRight);
+            tessellator.setColorOpaque3f(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
             tessellator.addVertexWithUV(d12, d13, d15, d4, d6);
         } else {
             tessellator.addVertexWithUV(d11, d13, d15, d8, d10);
@@ -508,11 +506,11 @@ public final class RenderBlocks {
         }
     }
 
-    public void renderTopFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
+    public void renderTopFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
         renderTopFace(tessellator, bounds, tilePos.x(), tilePos.y(), tilePos.z(), tex);
     }
 
-    public void renderTopFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
+    public void renderTopFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
         if (this.overrideBlockTexture != null) tex = this.overrideBlockTexture;
         if (tex == null) return;
         double d3 = tex.getSubIconU(bounds.minX());
@@ -569,17 +567,17 @@ public final class RenderBlocks {
         double d14 = z + bounds.minZ();
         double d15 = z + bounds.maxZ();
         if (this.enableAO) {
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordTopLeft);
-            tessellator.setColorOpaque_F(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
+            tessellator.setLightmapCoord1i(this.lightmapCoordTopLeft);
+            tessellator.setColorOpaque3f(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
             tessellator.addVertexWithUV(d12, d13, d15, d4, d6);
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordBottomLeft);
-            tessellator.setColorOpaque_F(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
+            tessellator.setLightmapCoord1i(this.lightmapCoordBottomLeft);
+            tessellator.setColorOpaque3f(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
             tessellator.addVertexWithUV(d12, d13, d14, d7, d9);
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordBottomRight);
-            tessellator.setColorOpaque_F(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
+            tessellator.setLightmapCoord1i(this.lightmapCoordBottomRight);
+            tessellator.setColorOpaque3f(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
             tessellator.addVertexWithUV(d11, d13, d14, d3, d5);
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordTopRight);
-            tessellator.setColorOpaque_F(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
+            tessellator.setLightmapCoord1i(this.lightmapCoordTopRight);
+            tessellator.setColorOpaque3f(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
             tessellator.addVertexWithUV(d11, d13, d15, d8, d10);
         } else {
             tessellator.addVertexWithUV(d12, d13, d15, d4, d6);
@@ -589,11 +587,11 @@ public final class RenderBlocks {
         }
     }
 
-    public void renderNorthFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
+    public void renderNorthFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
         renderNorthFace(tessellator, bounds, tilePos.x(), tilePos.y(), tilePos.z(), tex);
     }
 
-    public void renderNorthFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
+    public void renderNorthFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
         if (this.overrideBlockTexture != null) tex = this.overrideBlockTexture;
         if (tex == null) return;
         double d3 = tex.getSubIconU(bounds.minX());
@@ -655,17 +653,17 @@ public final class RenderBlocks {
         double d15 = y + bounds.maxY();
         double d16 = z + bounds.minZ();
         if (this.enableAO) {
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordTopLeft);
-            tessellator.setColorOpaque_F(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
+            tessellator.setLightmapCoord1i(this.lightmapCoordTopLeft);
+            tessellator.setColorOpaque3f(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
             tessellator.addVertexWithUV(d12, d15, d16, d8, d10);
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordBottomLeft);
-            tessellator.setColorOpaque_F(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
+            tessellator.setLightmapCoord1i(this.lightmapCoordBottomLeft);
+            tessellator.setColorOpaque3f(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
             tessellator.addVertexWithUV(d13, d15, d16, d3, d5);
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordBottomRight);
-            tessellator.setColorOpaque_F(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
+            tessellator.setLightmapCoord1i(this.lightmapCoordBottomRight);
+            tessellator.setColorOpaque3f(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
             tessellator.addVertexWithUV(d13, d14, d16, d9, d11);
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordTopRight);
-            tessellator.setColorOpaque_F(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
+            tessellator.setLightmapCoord1i(this.lightmapCoordTopRight);
+            tessellator.setColorOpaque3f(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
             tessellator.addVertexWithUV(d12, d14, d16, d4, d6);
         } else {
             tessellator.addVertexWithUV(d12, d15, d16, d8, d10);
@@ -675,11 +673,11 @@ public final class RenderBlocks {
         }
     }
 
-    public void renderSouthFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
+    public void renderSouthFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
         renderSouthFace(tessellator, bounds, tilePos.x(), tilePos.y(), tilePos.z(), tex);
     }
 
-    public void renderSouthFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
+    public void renderSouthFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
         if (this.overrideBlockTexture != null) tex = this.overrideBlockTexture;
         if (tex == null) return;
         double d3 = tex.getSubIconU(bounds.minX());
@@ -741,17 +739,17 @@ public final class RenderBlocks {
         double y1 = y + bounds.maxY();
         double z0 = z + bounds.maxZ();
         if (this.enableAO) {
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordTopLeft);
-            tessellator.setColorOpaque_F(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
+            tessellator.setLightmapCoord1i(this.lightmapCoordTopLeft);
+            tessellator.setColorOpaque3f(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
             tessellator.addVertexWithUV(x0, y1, z0, d3, d5);
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordBottomLeft);
-            tessellator.setColorOpaque_F(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
+            tessellator.setLightmapCoord1i(this.lightmapCoordBottomLeft);
+            tessellator.setColorOpaque3f(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
             tessellator.addVertexWithUV(x0, y0, z0, d9, d11);
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordBottomRight);
-            tessellator.setColorOpaque_F(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
+            tessellator.setLightmapCoord1i(this.lightmapCoordBottomRight);
+            tessellator.setColorOpaque3f(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
             tessellator.addVertexWithUV(x1, y0, z0, d4, d6);
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordTopRight);
-            tessellator.setColorOpaque_F(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
+            tessellator.setLightmapCoord1i(this.lightmapCoordTopRight);
+            tessellator.setColorOpaque3f(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
             tessellator.addVertexWithUV(x1, y1, z0, d8, d10);
         } else {
             tessellator.addVertexWithUV(x0, y1, z0, d3, d5);
@@ -761,11 +759,11 @@ public final class RenderBlocks {
         }
     }
 
-    public void renderWestFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
+    public void renderWestFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
         renderWestFace(tessellator, bounds, tilePos.x(), tilePos.y(), tilePos.z(), tex);
     }
 
-    public void renderWestFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
+    public void renderWestFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
         if (this.overrideBlockTexture != null) tex = this.overrideBlockTexture;
         if (tex == null) return;
         double d3 = tex.getSubIconU(bounds.minZ());
@@ -827,17 +825,17 @@ public final class RenderBlocks {
         double d15 = z + bounds.minZ();
         double d16 = z + bounds.maxZ();
         if (this.enableAO) {
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordTopLeft);
-            tessellator.setColorOpaque_F(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
+            tessellator.setLightmapCoord1i(this.lightmapCoordTopLeft);
+            tessellator.setColorOpaque3f(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
             tessellator.addVertexWithUV(d12, d14, d16, d8, d10);
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordBottomLeft);
-            tessellator.setColorOpaque_F(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
+            tessellator.setLightmapCoord1i(this.lightmapCoordBottomLeft);
+            tessellator.setColorOpaque3f(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
             tessellator.addVertexWithUV(d12, d14, d15, d3, d5);
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordBottomRight);
-            tessellator.setColorOpaque_F(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
+            tessellator.setLightmapCoord1i(this.lightmapCoordBottomRight);
+            tessellator.setColorOpaque3f(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
             tessellator.addVertexWithUV(d12, d13, d15, d9, d11);
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordTopRight);
-            tessellator.setColorOpaque_F(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
+            tessellator.setLightmapCoord1i(this.lightmapCoordTopRight);
+            tessellator.setColorOpaque3f(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
             tessellator.addVertexWithUV(d12, d13, d16, d4, d6);
         } else {
             tessellator.addVertexWithUV(d12, d14, d16, d8, d10);
@@ -847,11 +845,11 @@ public final class RenderBlocks {
         }
     }
 
-    public void renderEastFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
+    public void renderEastFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
         renderEastFace(tessellator, bounds, tilePos.x(), tilePos.y(), tilePos.z(), tex);
     }
 
-    public void renderEastFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
+    public void renderEastFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
         if (this.overrideBlockTexture != null) tex = this.overrideBlockTexture;
         if (tex == null) return;
         double uMin = tex.getSubIconU(bounds.minZ());
